| Wireshark 4.7.0 The Wireshark network protocol analyzer

Loading...
Searching...
No Matches
Classes | Macros | Typedefs | Functions
column.h File Reference
`#include "ws_symbol_export.h"`
`#include <epan/column-utils.h>`

Go to the source code of this file.

## Classes
struct | _fmt_data

## Macros
#define | COLUMN_DISPLAY_VALUES 'U'
#define | COLUMN_DISPLAY_STRINGS 'R'
#define | COLUMN_DISPLAY_DETAILS 'D'

## Typedefs
typedef struct _fmt_data | fmt_data

## Functions
WS_DLL_PUBLIC const char * | col_format_to_string (const int)
WS_DLL_PUBLIC const char * | col_format_desc (const int)
WS_DLL_PUBLIC const char * | col_format_abbrev (const int)
WS_DLL_PUBLIC int | get_column_format (const int)
WS_DLL_PUBLIC void | set_column_format (const int, const int)
WS_DLL_PUBLIC void | get_column_format_matches (bool *, const int)
WS_DLL_PUBLIC int | get_column_format_from_str (const char *)
WS_DLL_PUBLIC char * | get_column_title (const int)
WS_DLL_PUBLIC void | set_column_title (const int, const char *)
WS_DLL_PUBLIC bool | get_column_visible (const int)
WS_DLL_PUBLIC void | set_column_visible (const int, bool)
WS_DLL_PUBLIC char | get_column_display_format (const int)
WS_DLL_PUBLIC void | set_column_display_format (const int, char)
WS_DLL_PUBLIC const char * | get_column_custom_fields (const int)
WS_DLL_PUBLIC void | set_column_custom_fields (const int, const char *)
WS_DLL_PUBLIC int | get_column_custom_occurrence (const int)
WS_DLL_PUBLIC void | set_column_custom_occurrence (const int, const int)
WS_DLL_PUBLIC const char * | get_column_longest_string (const int)
WS_DLL_PUBLIC const char * | get_column_width_string (const int, const int)
WS_DLL_PUBLIC int | get_column_char_width (const int format)
WS_DLL_PUBLIC char * | get_column_tooltip (const int col)
WS_DLL_PUBLIC const char * | get_column_text (column_info *cinfo, const int col)
WS_DLL_PUBLIC void | col_finalize (column_info *cinfo)
WS_DLL_PUBLIC void | build_column_format_array (column_info *cinfo, const int num_cols, const bool reset_fences)
WS_DLL_PUBLIC void | column_dump_column_formats (void)
WS_DLL_PUBLIC bool | parse_column_format (fmt_data *cfmt, const char *fmt)
char * | column_fmt_data_to_str (const fmt_data *cfmt)
WS_DLL_PUBLIC void | try_convert_to_custom_column (char **fmt)
WS_DLL_PUBLIC const char * | try_convert_to_column_field (const char *field)
WS_DLL_PUBLIC void | column_register_fields (void)

## Detailed Description

Definitions for column handling routines Column preference and format settings.

For internal Wireshark useonly. Don't include this header in dissectors!

Wireshark - Network traffic analyzer By Gerald Combs geral.nosp@m.d@wi.nosp@m.resha.nosp@m.rk.o.nosp@m.rg Copyright 1998 Gerald Combs

SPDX-License-Identifier: GPL-2.0-or-later

## Macro Definition Documentation

## ◆ COLUMN_DISPLAY_VALUES

#define COLUMN_DISPLAY_VALUES 'U'

Defines used in fmt_data.display. The values are legacy from U Unresolved and R Resolved stored in the preferences.

## Function Documentation

## ◆ column_fmt_data_to_str()

char * column_fmt_data_to_str | ( | const fmt_data * | cfmt | ) |
| extern

Given a fmt_data struct, returns the column format string that should be written to the preferences to generate the fmt_data struct. The inverse of parse_column_format() above.

Parameters

  [in] | cfmt | The fmt_data struct.

Returns
  A column format string that corresponds to the fmt_data. This string is owned by the caller, and must be freed. Returns NULL if cfmt is NULL.

## ◆ get_column_text()

WS_DLL_PUBLIC const char * get_column_text | ( | column_info * | cinfo,
|  | const int | col
| ) |  |

Get the text of a column element. The string returned may depend on whether the resolved member variable is set. For internal Wireshark use, not to be called from dissectors. Dissectors use col_get_text() in column-utils.h

Parameters

  cinfo | the column information
  col | the column index to use (not the format)

Returns
  the text string

## ◆ parse_column_format()

WS_DLL_PUBLIC bool parse_column_format | ( | fmt_data * | cfmt,
|  | const char * | fmt
| ) |  |

Parse a column format string into a fmt_data struct. If the format string possibly can be that of a deprecated column that has been migrated to a custom column (e.g., upon first being read from a preference file), call try_convert_to_custom_column() first.

Parameters

  [out] | cfmt | The parsed cfmt, still owned by the caller. For custom columns, the caller is responsible for freeing the custom_fields member as well.
  [in] | fmt | The column format to parse.

Returns
  true if conversion was successful, false if unsuccessful

## ◆ try_convert_to_column_field()

WS_DLL_PUBLIC const char * try_convert_to_column_field | ( | const char * | field | ) |

Checks a column field string to see if it is a name of a filter field created using a default column title (as used in tshark -e), and alias it to the new column type based field.

Parameters

  [in] | field | The old title based field, e.g. "_ws.col.Info"

Returns
  The new field, e.g. "_ws.col.info", or NULL

## ◆ try_convert_to_custom_column()

WS_DLL_PUBLIC void try_convert_to_custom_column | ( | char ** | fmt | ) |

Checks a column format string to see if it is a deprecated column that has been migrated to a custom column, and converts the format to the corresponding custom column format if so, otherwise leaving it unchanged.

Parameters

  [in,out] | fmt | The column format to check and possibly convert.